/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.enums.EnumDatatype;
import de.ship.db.tables.records.VInputVariableRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VInputVariable extends TableImpl<VInputVariableRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_input_variable</code>
     */
    public static final VInputVariable V_INPUT_VARIABLE = new VInputVariable();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VInputVariableRecord> getRecordType() {
        return VInputVariableRecord.class;
    }

    /**
     * The column <code>common_dd.v_input_variable.key_variable</code>.
     */
    public final TableField<VInputVariableRecord, Integer> KEY_VARIABLE = createField(DSL.name("key_variable"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_variable.hier_lang</code>.
     */
    public final TableField<VInputVariableRecord, String> HIER_LANG = createField(DSL.name("hier_lang"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_input_variable.key_parent_element</code>.
     */
    public final TableField<VInputVariableRecord, Integer> KEY_PARENT_ELEMENT = createField(DSL.name("key_parent_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_variable.data_type</code>.
     */
    public final TableField<VInputVariableRecord, EnumDatatype> DATA_TYPE = createField(DSL.name("data_type"), SQLDataType.VARCHAR.asEnumDataType(EnumDatatype.class), this, "");

    /**
     * The column <code>common_dd.v_input_variable.fk_var_valuelist</code>.
     */
    public final TableField<VInputVariableRecord, Integer> FK_VAR_VALUELIST = createField(DSL.name("fk_var_valuelist"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_variable.var_order</code>.
     */
    public final TableField<VInputVariableRecord, Integer> VAR_ORDER = createField(DSL.name("var_order"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_variable.var_ecrf</code>.
     */
    public final TableField<VInputVariableRecord, Integer> VAR_ECRF = createField(DSL.name("var_ecrf"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_variable.var_formposx</code>.
     */
    public final TableField<VInputVariableRecord, Integer> VAR_FORMPOSX = createField(DSL.name("var_formposx"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_variable.var_formposy</code>.
     */
    public final TableField<VInputVariableRecord, Integer> VAR_FORMPOSY = createField(DSL.name("var_formposy"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_variable.fk_var_inputtype</code>.
     */
    public final TableField<VInputVariableRecord, Integer> FK_VAR_INPUTTYPE = createField(DSL.name("fk_var_inputtype"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_variable.default_value</code>.
     */
    public final TableField<VInputVariableRecord, Integer> DEFAULT_VALUE = createField(DSL.name("default_value"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_variable.fk_var_inputhelp</code>.
     */
    public final TableField<VInputVariableRecord, Integer> FK_VAR_INPUTHELP = createField(DSL.name("fk_var_inputhelp"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_variable.label_position</code>.
     */
    public final TableField<VInputVariableRecord, Integer> LABEL_POSITION = createField(DSL.name("label_position"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_variable.order_nr</code>.
     */
    public final TableField<VInputVariableRecord, Integer> ORDER_NR = createField(DSL.name("order_nr"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_variable.dn</code>.
     */
    public final TableField<VInputVariableRecord, String> DN = createField(DSL.name("dn"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_input_variable.stage</code>.
     */
    public final TableField<VInputVariableRecord, Integer> STAGE = createField(DSL.name("stage"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_variable.short_name</code>.
     */
    public final TableField<VInputVariableRecord, String> SHORT_NAME = createField(DSL.name("short_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_input_variable.unit_trans_key</code>.
     */
    public final TableField<VInputVariableRecord, String> UNIT_TRANS_KEY = createField(DSL.name("unit_trans_key"), SQLDataType.CLOB, this, "");

    private VInputVariable(Name alias, Table<VInputVariableRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VInputVariable(Name alias, Table<VInputVariableRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_input_variable" as  SELECT v.key_variable,
          h.hier_lang,
          h.key_parent_element,
          v.data_type,
          v.fk_var_valuelist,
          iv.var_order,
          iv.var_ecrf,
          iv.var_formposx,
          iv.var_formposy,
          iv.fk_var_inputtype,
          iv.default_value,
          iv.fk_var_inputhelp,
          iv.label_position,
          h.order_nr,
          h.dn,
          h.stage,
          h.short_name,
          u.fk_trans_key AS unit_trans_key
         FROM (((common_dd.t_core_variable v
           RIGHT JOIN common_dd.t_input_variable iv ON ((v.key_variable = iv.fk_variable)))
           JOIN common_dd.t_core_element_hierarchy h ON ((h.key_element = v.key_variable)))
           LEFT JOIN common_dd.t_core_unit u ON ((v.fk_unit = u.pk)))
        WHERE (iv.var_ecrf <> 0);
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_input_variable</code> table reference
     */
    public VInputVariable(String alias) {
        this(DSL.name(alias), V_INPUT_VARIABLE);
    }

    /**
     * Create an aliased <code>common_dd.v_input_variable</code> table reference
     */
    public VInputVariable(Name alias) {
        this(alias, V_INPUT_VARIABLE);
    }

    /**
     * Create a <code>common_dd.v_input_variable</code> table reference
     */
    public VInputVariable() {
        this(DSL.name("v_input_variable"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VInputVariable as(String alias) {
        return new VInputVariable(DSL.name(alias), this);
    }

    @Override
    public VInputVariable as(Name alias) {
        return new VInputVariable(alias, this);
    }

    @Override
    public VInputVariable as(Table<?> alias) {
        return new VInputVariable(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VInputVariable rename(String name) {
        return new VInputVariable(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VInputVariable rename(Name name) {
        return new VInputVariable(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VInputVariable rename(Table<?> name) {
        return new VInputVariable(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputVariable where(Condition condition) {
        return new VInputVariable(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputVariable where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputVariable where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputVariable where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VInputVariable where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VInputVariable where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VInputVariable where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VInputVariable where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputVariable whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputVariable whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
